<?php


namespace FiloBlu\CustomerAccountAge\Model;

class Core
{
    const ATTRIBUTE_CODE = '_points';

    protected $_resource;
    protected $connection = false;
    protected $setup;

    public function __construct(
        \Magento\Framework\App\ResourceConnection $resource,
        \FiloBlu\CustomerAccountAge\Setup\Patch\Data\AddAgeDaysCustomerAttribute $setup
    )
    {
        $this->_resource = $resource;
        $this->setup = $setup;
    }

    public function executeUpdate(){
        $allAges = $this->getAllAges();

        if(count($allAges) == 0){
            return false;
        }

        $attribute_code = $this->setup->getAttributeCode();
        $sql = "SELECT attribute_id FROM eav_attribute WHERE attribute_code = '{$attribute_code}' AND entity_type_id = 1;";
        $attribute_id = $this->_resource->getConnection()->fetchOne($sql);

        if(!$attribute_id){
            return false;
        }

        // Building a single update query
        $update_queries = array();
        foreach ($allAges as $customer_age_data) {
            $update_queries[] = " ({$attribute_id}, {$customer_age_data['entity_id']}, {$customer_age_data['age_days']})\n ";
        }

        // Here we probably have a lot of updates
        // Splitting the array into 5000 chunks to preserve performance

        $chunks = array_chunk($update_queries,5000,true);

        foreach ($chunks as $chunk) {

            $update_queries_string = implode(",",$chunk);
            $sql = " INSERT INTO customer_entity_varchar (attribute_id, entity_id, value) VALUES \n";
            $sql .= $update_queries_string;
            $sql .= " ON DUPLICATE KEY UPDATE value=VALUES(value); ";

            $this->_resource->getConnection()->query($sql);

        }

        return true;
    }

    protected function getConnection()
    {
        if (!$this->connection) {
            $this->connection = $this->_resource->getConnection('core_write');
        }
        return $this->connection;
    }

    protected function getAllAges(){
        $sql = "SELECT CE.entity_id
                ,CE.store_id
                ,CE.website_id
                ,CE.email
                ,CE.group_id
                ,CE.created_at
                ,DATEDIFF(CAST(NOW() AS DATE), CAST(CE.created_at AS DATE)) AS 'age_days'
                FROM customer_entity CE";
        $result = $this->getConnection()->fetchAll($sql);
        return $result;
    }
}